project/models.py
from project import db
import datetime
#from project import engine, Base
#from sqlalchemy.ext.declarative import declarative_base
#from sqlalchemy import ForeignKey,Column, Integer,String, Date
#from sqlalchemy.orm import relationship



class Courses(db.Model):

    __tablename__ = "courses"

    id = db.Column(db.Integer, primary_key=True)
    name = db.Column(db.String(length=50), nullable=False)
    duration = db.Column(db.Integer, nullable=False)


    def __init__(self,name=None,duration=None):
        self.name = name
        self.duration = duration

class Instructors(db.Model):

    __tablename__ = "instructors"

    id = db.Column(db.Integer, primary_key=True)
    name = db.Column(db.Integer, nullable=False)

    def __init__(self,name=None):
        self.name = name

class Classes(db.Model):

    __tablename__ = "classes"

    id = db.Column(db.Integer, primary_key=True)
    instructor_id = db.Column(db.Integer, db.ForeignKey('instructors.id'))
    users_id = db.Column(db.Integer, db.ForeignKey('users.id'))
    start_date = db.Column(db.Date, nullable=False)
    end_date = db.Column(db.Date, nullable=False)


    def __init__(self,instructor=None,start_date=None,end_date=None):
        self.instructor = instructor
        self.start_date = start_date
        self.end_date = end_date

class Users(db.Model):

    __tablename__ = "users"

    id = db.Column(db.Integer, primary_key=True)
    name = db.Column(db.String(length=50), unique=True, nullable=False)
    email = db.Column(db.String(length=50), unique=True, nullable=False)
    password = db.Column(db.String(length=50), nullable=False)
    courses = db.relationship('Classes')
    role = db.Column(db.String(length=50), default='user')

    def __init__(self, name=None, email=None,password=None,role=None):
        self.name = name
        self.email = email
        self.password = password
        self.role = role

project/users/forms.py
from flask_wtf import FlaskForm
from wtforms import StringField, PasswordField
from wtforms.validators import DataRequired, Length, EqualTo, Email


class RegisterForm(FlaskForm):
     name = StringField('Username', validators=[DataRequired(), Length(min=6, max=25)])
     email = StringField('Email', validators=[DataRequired(), Email(), Length(min=6, max=40)])
     password = PasswordField('Password', validators=[DataRequired(), Length(min=6, max=40)])
     confirm = PasswordField('Repeat Password', validators=[DataRequired(), EqualTo('password')])


class LoginForm(FlaskForm):
    name = StringField('Username', validators=[DataRequired()])
    password = PasswordField('Password', validators=[DataRequired()])

project/__init__.py
from flask import Flask
from flask_sqlalchemy import SQLAlchemy
from flask_migrate import Migrate

app = Flask(__name__)
app.config.from_pyfile('_config.py')
db = SQLAlchemy(app)

#Base = declarative_base()
#engine = create_engine(app.config['SQLALCHEMY_DATABASE_URI'])

from project.users.views import users_blueprint
from project.courses.views import courses_blueprint


app.register_blueprint(users_blueprint)
app.register_blueprint(courses_blueprint)


migrate = Migrate(app,db)

project/courses/views.py
from functools import wraps
from flask import request, redirect, flash,render_template, session, url_for, Blueprint
from project.models import Courses


courses_blueprint = Blueprint("courses",__name__)


def login_required(endpoint):
    @wraps(endpoint)
    def wrap(*args, **kwargs):
        if 'logged_in' in session:
            return endpoint(*args, **kwargs)
        else:
            flash('Necessário o login!!!')
            return(redirect(url_for('users.login')))
    return wrap


@courses_blueprint.route('/courses', methods=['GET'])
@login_required
def courses():
    courses = Courses.query.all()
    return render_template('listCourses.html',username=session['name'],courses=courses)

project/users/views.py
from flask import redirect , render_template, request, session, flash, url_for, Blueprint
from .forms import LoginForm, RegisterForm
#from project import engine, Base
from project.models import Users
#from sqlalchemy.orm import scoped_session,sessionmaker
from project import db
from sqlalchemy.exc import IntegrityError
from functools import wraps


users_blueprint = Blueprint("users", __name__)

#def dbSession():
#    Base.metadata.bind = engine
#    DBSession = scoped_session(sessionmaker(bind=engine))
#    return DBSession

def login_required(endpoint):
    @wraps(endpoint)
    def wrap(*args, **kwargs):
        if 'logged_in' in session:
            return endpoint(*args, **kwargs)
        else:
            flash('Necessário o login!!!')
            return(redirect(url_for('users.login')))
    return wrap


@users_blueprint.route('/', methods=['GET','POST'])
def login():
    error = None
    form = LoginForm(request.form)

    if request.method == 'POST':
        if form.validate_on_submit():
            #db_session = dbSession()
            #user = db_session.query(Users).filter_by(name=request.form['name']).first()
            user = Users.query.filter_by(name=request.form['name']).first()
            if user is not None and user.password == request.form['password']:
                session['logged_in'] = True
                session['user_id'] = user.id
                session['role'] = user.role
                session['name'] = user.name
                flash('Bem vindo ao Painel de Cursos!!!')
                return redirect(url_for('courses.courses'))
            else:
                error = "Usuário ou senha errada!!!"

    return render_template('login.html', form=form, error=error)


@users_blueprint.route('/logout',methods=['GET'])
@login_required
def logout():
    session.pop('logged_in',None)
    session.pop('user_id',None)
    session.pop('role',None)
    session.pop('name',None)
    return redirect(url_for('users.login'))

@users_blueprint.route("/register", methods=['GET','POST'])
def register():
    error = None
    form = RegisterForm(request.form)

    if request.method == 'POST':
        if form.validate_on_submit():
            new_user = Users(
                request.form['name'],
                request.form['email'],
                request.form['password'],
                request.form['confirm'])
            print(request.form['name'])
            try:
                db.session.add(new_user)
                db.session.commit()
                flash('Obrigado por se registrar!!!')
                return redirect(url_for('users.login'))
            except IntegrityError:
                error = 'Esse usuário ou email já foram registrados'
                return render_template('register.html', form=form, error=error)
    return render_template('register.html', form=form, error=error)

project/templates/_base.html
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <title>Simple Python3 + Flask App</title>
  <link rel="stylesheet" href="{{url_for('static',filename="css/main.css")}}">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css" integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm" crossorigin="anonymous">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
  <style media="screen">
    body { background-color: #009999; }
  </style>
</head>
<body >

    {% for message in get_flashed_messages() %}
      <div class="alert alert-success text-center" id="alert">{{ message }}</div>
    {% endfor %}

    {% if error %}
      <div class="alert alert-danger text-center"><strong>Error: </strong>{{ error }}</div>
    {% endif %}

    <div class="">
      {% block content %}
      {% endblock %}
    </div>

  <script src="https://code.jquery.com/jquery-3.2.1.slim.min.js" integrity="sha384-KJ3o2DKtIkvYIK3UENzmM7KCkRr/rE9/Qpg6aAZGJwFDMVNA/GpGFF93hXpG5KkN" crossorigin="anonymous"></script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.12.9/umd/popper.min.js" integrity="sha384-ApNbgh9B+Y1QKtv3Rn7W3mgPxhU9K/ScQsAP7hUibX39j7fakFPskvXusvfa0b4Q" crossorigin="anonymous"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/js/bootstrap.min.js" integrity="sha384-JZR6Spejh4U02d8jOt6vLEHfe/JQGiRRSQQxSfFWpi1MquVdAyjUar5+76PVCmYl" crossorigin="anonymous"></script>
</body>
</html>

project/templates/listCourses.html
<nav class="navbar navbar-expand-lg   navbar-light bg-light">
 <a class="navbar-brand" href="#">
   <img src="https://2via.4linux.com.br/image/logo.png" width="100" height="30" class="d-inline-block align-top" alt=""></img>
 </a>
 <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarNavAltMarkup" aria-controls="navbarNavAltMarkup" aria-expanded="false" aria-label="Toggle navigation">
     <span class="navbar-toggler-icon"></span>
 </button>
 <div class="collapse navbar-collapse" id="navbarNavAltMarkup">
   <ul class='nav navbar-nav navbar-right'>
     {% if not session.logged_in %}
      <a class='nav-item nav-link' href="{{url_for('users.register')}}">Signup</a></li>
     {% else %}
      <a class='nav-item nav-link' href="#">Bem vindo, {{username}}.</a>
      <a class='nav-item nav-link' href="{{url_for('users.logout')}}"><span class="fa fa-sign-out"></span></a>
     {% endif %}
   </ul>
 </div>
</nav>


{% extends "_base.html" %}
{% block content %}


  <div class="card-columns courses-list text-center">
    {% for course in courses %}
    <div class="card" style="width: 18rem;">
      <img class="card-img-top" src="static/images/courses-linux-thumbnail.png" alt="Card image cap">
      <div class="card-body">
        <h5 class="card-title">{{course.name}}</h5>
      </div>
      <ul class="list-group list-group-flush">
        <li class="list-group-item"><span class="fa fa-clock-o"></span>  {{course.duration}} horas </li>
        <li class="list-group-item"><span class="fa fa-calendar"></span>  10/10/2020 - 14/10/2020</li>
      </ul>
    </div>  <!-- Ending courses-list content -->
    {% endfor %}
  </div>

{% endblock %}

project/templates/login.html
{% extends "_base.html" %}
{% block content %}

  <div class="modal-dialog">


    <div class="modal-content col-sm-12 text-center">
	    <div class="login-logo col-12">
	  	  <img src="https://2via.4linux.com.br/image/logo.png"/>
	    </div>


      <form action="/" class="col-12" method="post">
          {{ form.csrf_token }}
          <div class="form-group">
            <!-- <input type="text" name="username" class="form-control" placeholder="Enter Username" value="{{ request.form.username }}" > -->
            {{ form.name(placeholder="Username", class="form-control")}}
            {% if form.name.errors %}
            <div class="alert alert-danger">
              {% for error in form.name.errors %}
                {{error}}
              {% endfor %}
            </div>
            {% endif %}
          </div>
          <div class="form-group">
            <!-- <input type="password" name="password" class="form-control" placeholder="Enter Password" value="{{ request.form.password }}"> -->
            {{ form.password(placeholder="Password",  class="form-control" )}}
            {% if form.password.errors %}
            <div class="alert alert-danger">
              {% for error in form.password.errors %}
                {{error}}
              {% endfor %}
            </div>
            {% endif %}
          </div>
          <button class="btn btn-lg btn-primary" value="Login" type="submit" id="loginbutton"><i class="fa fa-sign-in" aria-hidden="true"></i> Login</button>
      </form>

      <div class="registry-redirect">
        If you are not registry click <a href="/register">here</a>
      </div>


    </div>
  </div>

{% endblock %}

project/templates/register.html
{% extends "_base.html"%}
{% block content %}

<div class="modal-dialog">


  <div class="modal-content col-sm-12 text-center">
    <div class="login-logo col-12">
      <img src="https://2via.4linux.com.br/image/logo.png"/>
    </div>


    <form action="/register" class="col-12" method="post">
        {{ form.csrf_token }}
        <div class="form-group">
          {{ form.name(placeholder="Username", class="form-control")}}
          {% if form.name.errors %}
          <div class="alert alert-danger">
            {% for error in form.name.errors %}
              {{error}}
            {% endfor %}
          </div>
          {% endif %}
        </div>
        <div class="form-group">
          {{ form.email(placeholder="Email", class="form-control")}}
          {% if form.email.errors %}
          <div class="alert alert-danger">
            {% for error in form.email.errors %}
              {{error}}
            {% endfor %}
          </div>
          {% endif %}
        </div>
        <div class="form-group">
          {{ form.password(placeholder="Password",  class="form-control" )}}
          {% if form.password.errors %}
          <div class="alert alert-danger">
            {% for error in form.password.errors %}
              {{error}}
            {% endfor %}
          </div>
          {% endif %}
        </div>
        <div class="form-group">
          {{ form.confirm(placeholder="Repeat Password",  class="form-control" )}}
          {% if form.confirm.errors %}
          <div class="alert alert-danger">
            {% for error in form.confirm.errors %}
              {{error}}
            {% endfor %}
          </div>
          {% endif %}
        </div>
        <button class="btn btn-lg btn-primary" value="Register" type="submit"><i class="fa fa-sign-in" aria-hidden="true"></i> Registry</button>
    </form>

  </div>
</div>




{% endblock %}